<?php

namespace App\Jobs;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldBeUnique;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;

class firebasePainelOrganizadora implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     */
    public function __construct()
    {
        //
    }

    /**
     * Execute the job.
     */
    public function handle(): void
    {
        //
        $organizadora = DB::select("select ore.id as regiao_id,
                                                ore.evento_id,
                                                ore.descricao as regiao_organizadora,
                                                ore.numero_representantes,
                                                (select count(om.id)
                                                from organizadora_membros om
                                                inner join inscricoes	i		on	i.id			= om.inscricao_id and
                                                                                i.evento_id		= e.id and
                                                                                i.organizadora_regiao_id = ore.id
                                                where om.evento_id = e.id

                                                ) as numero_escolhido,
                                                (    select count(distinct i.plenario_regiao_id)

                                                            from    eventos        e
                                                                inner join inscricoes    i        on i.evento_id        = e.id
                                                                inner join pessoas        p        on    p.id = i.pessoa_id
                                                                inner join organizadora_regioes ore2 on ore.id = i.organizadora_regiao_id  and ore2.id = ore.id

                                                            where    e.id = ore.evento_id

                                                            ) as qtd_nomeados

                                            from organizadora_regioes ore
                                            inner join eventos		e		on	e.id = ore.evento_id");

                                            // Log::info($organizadora);

        if(count($organizadora) > 0){

            // Get the database client
            $database = app('firebase.database');

            $cont = 0;
            $event_comp_id = $organizadora[0]->evento_id;
            foreach ($organizadora as $org) {
                    if($event_comp_id != $org->evento_id){
                        $event_comp_id = $org->evento_id;
                        $cont = 0;
                    }
                    // Get the reference to the data
                    $reference = $database->getReference(env('APP_ENV') .'/organizadora_painel/' . $org->evento_id . '/' . $cont );

                    // Update the data
                    $reference->update(['regiao_organizadora' => $org->regiao_organizadora, 'numero_representantes' => $org->numero_representantes, 'numero_escolhido' => $org->numero_escolhido, 'qtd_nomeados' => $org->qtd_nomeados, 'regiao_id'=> $org->regiao_id]);

                    $cont++;
            }

        }
    }
}
